import java.io.*;
import java.util.Scanner;
import java.awt.event.*;
import java.text.*;
import javax.swing.*;

public class TestStage2
{
	public static void main(String[ ] args)
	{
		SemaforoP semp = new SemaforoP(5,4);
		DetectorDeRequerimiento boton = new DetectorDeRequerimiento();
		Controlador control = new Controlador(boton , semp);
		SimuladorEntradas simu = new SimuladorEntradas(boton, args[0]);
		simu.start();
		control.manageTraffic();
	}
}
class DetectorDeRequerimiento
{
	public boolean isOn()
	{
		return encendido;
	}

	public void setOn()
	{
		encendido = true;
	}

	public void setOff()
	{
		encendido = false;
	}

	public String toString()
	{
		if (encendido == true)
			return "1";
		else
			return "0";
	}

	private boolean encendido;
}

class SemaforoP
{
	public SemaforoP(int greenTime, int blinkingTime)
	{
		tiempo_verde = greenTime;
		tiempo_parpadeo = blinkingTime;
		rojo = true;
	}

	public void turnRedLightOn()
	{
		rojo = true;
	}

	public void turnGreenLightOn()
	{
		rojo = false;
		verde = true;
	}

	public void turnGreenLightOff()
	{
		verde = false;
	}

	public int getGreenLightTime()
	{
		return tiempo_verde;
	}

	public int getBlinkingTime()
	{
		return tiempo_parpadeo;
	}

	public String toString()
	{
		if (rojo == true)
			return "0";
		else
			return "1";
	}
	private int tiempo_verde;
	private int tiempo_parpadeo;
	private boolean rojo;
	private boolean verde;
}


class Controlador extends Thread
{ 
	public Controlador(DetectorDeRequerimiento boton, SemaforoP semp)
	{  
		button = boton;
		sema = semp;
		tiempoverde = semp.getGreenLightTime();
		tiempo_parpadeo = semp.getBlinkingTime(); 
	}
 
	public void manageTraffic()
	{
		boolean isOn = false;
		int tiempo = 0;
		//Delay para sincronizar con el delay del boton.
		try
		{
			Thread.sleep(1000);
		}
		catch(InterruptedException e)
		{
			System.out.println(e);
		}
		while(true)
		{
			isOn = button.isOn();
			if (isOn)
			{
				sema.turnGreenLightOn();
				int conta = 0;
				while(conta < tiempoverde-1)
				{
					System.out.println(tiempo + "  " + sema);
					try
					{
						Thread.sleep(1000);
					}
					catch(InterruptedException e)
					{
						System.out.println(e);
					}
					tiempo++;
					conta++;
				}
				System.out.println(tiempo + "  " + sema);
				int contador = 0;
				int c = 0;
				while(true)
				{
					if (contador < tiempo_parpadeo)
					{
						if (c%2!=0)
						{
							sema.turnGreenLightOff();
							try
							{
								Thread.sleep(250);
							}
							catch(InterruptedException e)
							{
								System.out.println(e);
							}
						}
						else 
						{
							sema.turnGreenLightOn();
							try
							{
								Thread.sleep(250);
							}
							catch(InterruptedException e)
							{
								System.out.println(e);
							}
						}
						c++;
						if (c%4==0)
						{
							tiempo++;
							contador++;
							System.out.println(tiempo + "  " + sema);
						}
					}
					else
					{
						break;
					}
				}
			button.setOff();
			}
			else
			{
				sema.turnGreenLightOff();
				sema.turnRedLightOn();
				System.out.println(tiempo + "  " + sema);
			};
			try
			{
				Thread.sleep(1000);
			}
			catch(InterruptedException e)
			{
				System.out.println(e);
			}
			tiempo++;
		}
	}
	private int tiempo_parpadeo;
	private int tiempoverde;
	private DetectorDeRequerimiento button;
	private SemaforoP sema;
}
class SimuladorEntradas
{  
	public SimuladorEntradas(DetectorDeRequerimiento boton, String filename)
	{
		try
		{
			temporal = new File (filename);
			archivo = new Scanner (temporal);
			detector = boton;
		}
		catch(Exception ex)
		{
		  ex.printStackTrace();
		}
	}	
	public void start()  
	{
		class Leer implements ActionListener 
		{
			public Leer()
			{
				
			}
			public void actionPerformed(ActionEvent event)
			{
				if (archivo.hasNext())
				{
					String linea = archivo.nextLine();
					if (linea.equals("1"))
					{
						detector.setOn();
					}
				}
				else 
				{
					System.exit(0);
				}
			}
		}
		ActionListener lectura = new Leer();
		Timer t = new Timer(1000, lectura);
		t.start();
	}
	private DetectorDeRequerimiento detector;
	private File temporal;
	private Scanner archivo;
}